#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_AbysmFishingKingSignCFG.h"
std::auto_ptr<M_AbysmFishingKingSignCFG> M_AbysmFishingKingSignCFG::msSingleton(nullptr);

int M_AbysmFishingKingSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_AbysmFishingKingSignCFGData* M_AbysmFishingKingSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_AbysmFishingKingSignCFGData>& M_AbysmFishingKingSignCFG::GetMapData()
{
	return mMapData;
}

void M_AbysmFishingKingSignCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_AbysmFishingKingSignCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_AbysmFishingKingSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		data.mRewardItem = element->IntAttribute("RewardItem");
		data.mRewardQuantity = element->IntAttribute("RewardQuantity");
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_AbysmFishingKingSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_AbysmFishingKingSignCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_AbysmFishingKingSignCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_AbysmFishingKingSignCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_AbysmFishingKingSignCFGData data;
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readInt(L, "RewardQuantity", data.mRewardQuantity);
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_AbysmFishingKingSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_AbysmFishingKingSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_AbysmFishingKingSignCFG* M_AbysmFishingKingSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_AbysmFishingKingSignCFG());
	}
	return msSingleton.get();
}

void M_AbysmFishingKingSignCFG::Release()
{
	msSingleton.reset(nullptr);
}
